<?php
  /**
  * Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración PÃºblica Venezolana
  * @file accion_especifica_de_proyecto_seguimiento.module
  * Drupal part Module to code proyectos operativos module
  * Copyright 2012 Sistema Automatizado para la Planificación EstratÃ©gico-Situacional en la Administración PÃºblica Venezolana (CENDITEL)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  * 
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  *
  * @author CENDITEL Merida - Ing. Diego Uzcategui
  * @date 2013-02-07 // (anno-mes-dia)
  * @version 0.1
  *
  */
  
/*
 * Implementation of acciones_centralizadas_seguimiento_wk_tab_page_form()
 */
function cambiodeestado_seg_ae_proyecto_paginaconfirmacion_form($form_state, $node, $mes = 0, $state) {
  $estados = _obtener_estados_seguimiento_mes();
  
  $consultaseguimientoactual = _seguimiento_mesactual_partida_ae_deproyecto_load($node, $mes);
  
  $form = array();
  $form['#node'] = $node;
  $form['#segmes'] = $consultaseguimientoactual['segmes'];
  $form['#nuevo_estado'] = $state;
  $form['#estados'] = $estados['states'];
  $form['#mes'] = $mes;
  $form['comentario'] = array(
    '#title' => t('Comentario'),
    '#type' => 'textarea',
    '#default_value' => '',
  );
  
  $expr_mach = _nombres_estado_y_transiciones($estados['states'][$state]);
  if(isset($expr_mach['nombre_corto'])){
    $message = t('¿Está seguro(a) que desea %accionarealizar?', array('%accionarealizar' => $expr_mach['nombre_largo']));
    $caption = '<p>'. t('This action cannot be undone.') .'</p>';
    $return_path = 'node/' . $node->nid . '/seguimiento_aeproyecto';
    return confirm_form($form, $message, $return_path, $caption, t('Aceptar'));
  }else{
    $message = t('¿Está seguro(a) que desea cambiar el seguimiento al estado %nombre_estado?', array('%nombre_estado' => $estados['states'][$state]));
    $caption = '<p>'. t('This action cannot be undone.') .'</p>';
    $return_path = 'node/' . $node->nid . '/seguimiento_aeproyecto';
    return confirm_form($form, $message, $return_path, $caption, t('Cambiar'));
  }
}

/**
 * Implementation of acciones_centralizadas_seguimiento_wk_tab_page_form_submit().
 * Process funcion delete confirm form.
 */
function cambiodeestado_seg_ae_proyecto_paginaconfirmacion_form_submit($form, &$form_state) {
  global $user;
  
  db_query("INSERT INTO {seguimiento_aeproyecto_transiciones_estados} (estado, estado_ant, comentario, date, id_seg, uid) VALUES (%d, %d, '%s', %d, %d, %d)", $form['#nuevo_estado'], $form['#segmes']['estado'], check_plain($form_state['values']['comentario']), time(), $form['#segmes']['id_seg'], $user->uid); 
  
  $ultima_id_transicion_seg = db_query("SELECT max(a.id_seg_transicion_estado) AS id FROM {seguimiento_aeproyecto_transiciones_estados} AS a WHERE a.id_seg = %d", $form['#segmes']['id_seg']);
  $seg_transicion_estado = db_fetch_object($ultima_id_transicion_seg);
  
  db_query('UPDATE {seguimiento_aeproyecto} SET estado = %d, id_seg_transicion_estado = %d WHERE id_seg = %d', $form['#nuevo_estado'], $seg_transicion_estado->id, $form['#segmes']['id_seg']);
  
  drupal_set_message(t('El seguimiento fue cambiado al estado @nombre_estado', array('@nombre_estado' => $form['#estados'][$form['#nuevo_estado']])));
  $form_state['redirect'] = 'node/' . $form['#node']->field_accion_esp_proyecto[0]['nid'] . '/fase_de_seguimiento_proyecto_y_aes/mes/'.$form['#mes'];
  
}
